﻿;
; ╔═════════════════════════════════════════════════════════════════════════╗
; ║     This file is generated by The Interactive Disassembler (IDA)        ║
; ║     Copyright (c) 2006 by DataRescue sa/nv, <ida@datarescue.com>        ║
; ║ Licensed to: Torukh Makhto                                              ║
; ╚═════════════════════════════════════════════════════════════════════════╝
;
; Input MD5   : 463037485F1D69986AF87481DD69BA32

; ───────────────────────────────────────────────────────────────────────────
; File Name   : EDFAT.DSS
; Format      : Binary file
; Base Address: 0000h Range: 2000h - 228Eh Loaded length: 028Eh

; Processor:        K1801VM1
; Target assembler: BK Turbo8 Cross Assembler

.include "inc\DESSParam.asm"
.include "inc\ANDOSParam.asm"


; ═══════════════════════════════════════════════════════════════════════════
; Редактор FAT диска ANDOS by Camcoder
; оригинал был рассчитан на работу исключительно в ANDOS 2.50 и ниже
; исправлено для работы во всех версиях

EDFAT:          mov     #14, R0
                emt     16
                clr     R1                  ; номер текущей ячейки FAT
                mov     @#INIDRV, -(SP)
                call    @(SP)+
                mov     @#RDFAT, -(SP)
                call    @(SP)+
                call    OutFAT              ; Вывод ячеек и их содержимого на экран.
                                            ; Вход: R1 - номер ячейки FAT, с которой начинается вывод
                clr     @#177130
                bis     #100, @#177660      ; запретим прерывания от клавиатуры

1$:             mov     R1, R3
2$:             bit     #100, @#177716      ; ждём нажатия клавиши
                bne     2$
                cmp     #32, @#177662       ; это стрелка вверх?
                bne     3$                  ; нет
                dec     R1                  ; перемещаемся к предыдущей
                call    ChkBounds           ; Проверка, чтобы не вышли за пределы допустимых номеров ячеек FAT
                                            ; Вход: R1 - новое значение
                                            ;       R3 - предыдущее значение
                cmp     R1, R3              ; если значение не изменилось, то двигаться некуда
                beq     3$
                movb    #32, R0             ; иначе - курсор вверх
                emt     16

3$:             cmp     #33, @#177662       ; это стрелка вниз?
                bne     4$                  ; нет
                inc     R1                  ; перемещаемся к следующей
                call    ChkBounds           ; Проверка, чтобы не вышли за пределы допустимых номеров ячеек FAT
                                            ; Вход: R1 - новое значение
                                            ;       R3 - предыдущее значение
                cmp     R1, R3              ; если значение не изменилось, то двигаться некуда
                beq     4$
                mov     #12, R0             ; иначе - перевод строки
                emt     16

4$:             cmp     #10, @#177662       ; это стрелка влево?
                bne     5$                  ; нет
                sub     #20, R1             ; сразу на 16. ячеек назад
                call    ChkBounds           ; Проверка, чтобы не вышли за пределы допустимых номеров ячеек FAT
                                            ; Вход: R1 - новое значение
                                            ;       R3 - предыдущее значение
                cmp     R1, R3              ; если значение не изменилось, то двигаться некуда
                beq     5$
                call    OutFAT              ; Вывод ячеек и их содержимого на экран.
                                            ; Вход: R1 - номер ячейки FAT, с которой начинается вывод

5$:             cmp     #31, @#177662       ; это стрелка вправо?
                bne     6$                  ; нет
                add     #20, R1             ; сразу на 16. ячеек вперёд
                call    ChkBounds           ; Проверка, чтобы не вышли за пределы допустимых номеров ячеек FAT
                                            ; Вход: R1 - новое значение
                                            ;       R3 - предыдущее значение
                cmp     R1, R3              ; если значение не изменилось, то двигаться некуда
                beq     6$
                call    OutFAT              ; Вывод ячеек и их содержимого на экран.
                                            ; Вход: R1 - номер ячейки FAT, с которой начинается вывод

6$:             cmp     #14, @#177662       ; это СБР?
                beq     11$                 ; да - идём редактировать
                cmp     #23, @#177662       ; это ВС?
                beq     EDFAT               ; да - перечитаем
7$:             cmp     #27, @#177662       ; это раздвижка в строке?
                bne     8$                  ; нет
                mov     @#WRFAT, -(SP)      ; иначе сохраним FAT
                call    @(SP)+
                clr     @#177130            ; и продолжим

8$:             cmp     #3, @#177662        ; это КТ?
                bne     9$                  ; нет
                mov     #14, R0             ; очистим экран
                emt     16
                bic     #100, @#177660      ; разрешим прерывания от клавиатуры
                return                      ; и выход из функции

9$:             cmp     #'H, @#177662       ; это H
                bne     10$                 ; нет
                call    OutHelp             ; выведем справку
; любые другие клавиши вызывают перерисовку текущей строки 
10$:            mov     #5032, R0           ; стрелка вверх и перевод строки
                emt     16
                swab    R0
                emt     16
                mov     R1, R5
                call    DecOut
                movb    #':, R0
                emt     16
                mov     R1, R0
                mov     @#GETFAT, -(SP)
                call    @(SP)+
                mov     R0, R5
                call    DecOut
                mov     R0, R5
                call    @#OCTOUT
                movb    #40, R0
                emt     16
                br      1$
; редактирование
11$:            bic     #100, @#177660
                mov     R1, -(SP)
                mov     R1, R4
                call    @#GETNUM
                mov     R4, R0
                mov     R5, R1
                mov     @#SETFAT, -(SP)
                call    @(SP)+
                mov     (SP)+, R1
                bis     #100, @#177660
                br      7$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Проверка, чтобы не вышли за пределы допустимых номеров ячеек FAT
; Вход: R1 - новое значение
;       R3 - предыдущее значение
ChkBounds:      cmp     R1, #651        ; меньше максимально возможного?
                blt     1$              ; да
                mov     R3, R1          ; иначе вернём предыдущее значение
1$:             tst     R1              ; больше равно нулю?
                bge     2$              ; да - всё в порядке
                mov     R3, R1          ; иначе вернём предыдущее значение
2$:             return
; End of function ChkBounds


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вывод ячеек и их содержимого на экран.
; Вход: R1 - номер ячейки FAT, с которой начинается вывод

OutFAT:         mov     R1, -(SP)
                mov     R2, -(SP)
                movb    #14, R0         ; очистка экрана
                emt     16
                mov     #26, R2         ; выведем каждую ячейку в столбик на весь экран
1$:             mov     #5032, R0       ; курсор вверх, перевод строки
                emt     16
                swab    R0
                emt     16
                mov     R1, R5
                call    DecOut
                movb    #':, R0
                emt     16
                mov     R1, R0
                mov     @#GETFAT, -(SP)
                call    @(SP)+
                mov     R0, R5
                call    DecOut
                mov     R0, R5
                call    @#OCTOUT        ; Вывод восьмеричного числа из R5.
                mov     #5040, R0       ; пробел и перевод строки
                emt     16
                swab    R0
                emt     16
                inc     R1
                sob     R2, 1$
                mov     #5022, R0       ; исходная установка курсора и перевод строки
                emt     16
                swab    R0
                emt     16
                mov     (SP)+, R2
                mov     (SP)+, R1
                return
; End of function OutFAT


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


OutHelp:        mov     R1, -(SP)
                mov     R2, -(SP)
                .addr   R1, Info
                clr     R2
                emt     20
                emt     4
                call    @#EMT6R
                reset
                mov     (SP)+, R2
                mov     (SP)+, R1
                movb    #14, R0
                emt     16
                call    OutFAT          ; Вывод ячеек и их содержимого на экран.
                                        ; Вход: R1 - номер ячейки FAT, с которой начинается вывод
                return
; End of function OutHelp

; ───────────────────────────────────────────────────────────────────────────
Info:           .ascii <14>"FAT EDITOR V1.05 by CAMCODER."<12><12>
                .ascii "Клавиши управления:"<12>
                .ascii "←,→,↑,↓   - перемещение,"<12>
                .ascii "СБР    - редактирование,"<12>
                .ascii "ВС    - перечитать FAT,"<12>
                .ascii "|=>    - запись FAT,"<12>
                .ascii "КТ    - ВЫХОД."<0>

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Вывод числа в десятичном виде
; Вход: R5 - число

DecOut:         mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     #'0, R0
                .addr   R2, DecExp
                mov     #5, R3
1$:             cmp     R5, (R2)
                blo     2$
                incb    R0
                sub     (R2), R5
                br      1$

2$:             emt     16
                mov     #'0, R0
                tst     (R2)+
                sob     R3, 1$
                mov     #'., R0
                emt     16
                mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R0
                return
; End of function DecOut

; ───────────────────────────────────────────────────────────────────────────
DecExp:         .word 10000.
                .word 1000.
                .word 100.
                .word 10.
                .word 1


                .END
